//+------------------------------------------------------------------+
/////////////CYCLE TRIANGULAR CENTERED END-POINT  
//////////////Sohocool March 2012

//|                                       
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
 
 
#property  indicator_separate_window
#property  indicator_buffers 4
#property indicator_color1 LawnGreen
#property indicator_color2 Red
#property  indicator_color3  Blue
#property  indicator_color4  Red
#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 1
#property indicator_width4 1


//---- indicator parameters
extern int Fast_HalfLength=24;    
extern int Slow_HalfLength=48;
extern int PRICE = 5; 
//extern int SignalSMA=1;

//---- indicator buffers
double     ind_Buffer1[];
double     ind_Buffer2[];
double     ind_buffer3a[];
double     ind_buffer3b[];
double     ind_buffer4[];
double     ind_buffer5[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- 2 additional buffers are used for counting.
   IndicatorBuffers(6);
//---- drawing settings
double SignalSMA =1;

   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexDrawBegin(0,SignalSMA);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexDrawBegin(1,SignalSMA);
   SetIndexStyle(4,DRAW_NONE);
   SetIndexBuffer(4,ind_Buffer1);
   SetIndexStyle(5,DRAW_NONE);
   SetIndexBuffer(5,ind_Buffer2);
   
   
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+2);
   
//---- 5 indicator buffers mapping
   IndicatorBuffers(6);
   SetIndexBuffer(0,ind_buffer3a);
   SetIndexBuffer(1,ind_buffer3b);
   SetIndexBuffer(2,ind_buffer4);
   SetIndexBuffer(3,ind_buffer5);
   SetIndexBuffer(4,ind_Buffer1);
   SetIndexBuffer(5,ind_Buffer2);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("Cycle Tma End-Point  ("+Fast_HalfLength+","+Slow_HalfLength+")");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Average of Oscillator                                     |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   for(int i=limit; i>=0; i--)  ind_buffer4[i]=iMA(NULL,0,Fast_HalfLength+1,0,3,PRICE,i) -iMA(NULL,0,Slow_HalfLength+1,0,3,PRICE,i);
   double value=0;
   double value1=0;
   for(i=limit; i>=0; i--)
      {
         ind_buffer3a[i]=0.0;
         ind_buffer3b[i]=0.0;      
         value=ind_buffer4[i];
         value1=ind_buffer4[i+1];
         if (value1<value) ind_buffer3a[i]=value;
         if (value1>value) ind_buffer3b[i]=value;
      }   
//---- done
   return(0);
  }
//+------------------------------------------------------------------+

